# encoding: utf-8
module Mobile
  module Entities
    class Whomework <Grape::Entity
      include ApiHelper
      include ApplicationHelper
      include Redmine::I18n
      def self.whomework_expose(f)
        expose f do |wh, opt|
          if wh.is_a?(Hash) && wh.key?(f)
            wh[f]
          elsif wh.is_a?(::HomeworkCommon)
            if wh.respond_to?(f)
              if f == :created_at
                format_time(wh.send(f))
              else
                wh.send(f)
              end
            else
              case f
                when :absence_penalty
                  wh.nil? || wh.homework_detail_manual.nil? ? 0 : wh.homework_detail_manual.absence_penalty
                when :evaluation_start
                  wh.nil? || wh.homework_detail_manual.nil? ? nil : convert_to_time(wh.homework_detail_manual.evaluation_start, 0)
                when :evaluation_end
                  wh.nil? || wh.homework_detail_manual.nil? ? nil : convert_to_time(wh.homework_detail_manual.evaluation_end, 1)
                when :praise_count
                  get_activity_praise_num(wh)
                when :whomework_journal_count
                  wh.journals_for_messages.count
                when :course_name
                  wh.course.name
                when :act_type
                  'HomeworkCommon'
                when :act_id
                  wh.id
              end
            end
          end
        end
      end

      expose :author, using: Mobile::Entities::User do |w, opt|
        if w.is_a?(::HomeworkCommon)
          w.user
        end
      end
      expose :current_user, using: Mobile::Entities::User do |w, opt|
        current_user
      end
      expose :name
      expose :description
      expose :publish_time
      expose :end_time
      expose :homework_type
      expose :late_penalty
      expose :course_id
      expose :anonymous_comment
      expose :quotes
      expose :is_open
      whomework_expose :act_type
      whomework_expose :act_id
      whomework_expose :course_name
      whomework_expose :created_at
      whomework_expose :absence_penalty
      whomework_expose :evaluation_start
      whomework_expose :evaluation_end
      whomework_expose :praise_count
      whomework_expose :whomework_journal_count
      expose :journals_for_messages, using: Mobile::Entities::Jours  do |f, opt|
        #f[:journals_for_messages] if f.is_a?(Hash) && f.key?(:journals_for_messages)
        if f.is_a?(::HomeworkCommon)
          f.journals_for_messages.reverse
        end
      end
      expose :has_praise , if: lambda { |instance, options| options[:user] } do |instance, options|
        has_praise = false
        current_user = options[:user]
        obj = PraiseTread.where("praise_tread_object_id=? and praise_tread_object_type=? and user_id=?",instance.id,instance.class.to_s,current_user.id)
        has_praise = obj.empty? ? false : true
        has_praise
      end
    end
  end
end